diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
index 44d929a40..ec3ceaed2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
@@ -3,29 +3,31 @@ package net.minecraft.client.render.block.color;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockColorWater extends BlockColorCustom {
 
 	public Minecraft mc = Minecraft.getMinecraft();
 	
-	public BlockColorWater(Colorizer colorizer) {
+	public BlockColorWater(@NotNull Colorizer colorizer) {
 		super(colorizer);
 	}
 	
 	@Override
 	public int getFallbackColor(int meta, int tintIndex) {
-		if(!mc.gameSettings.biomeWater.value || (mc.currentWorld != null && mc.currentWorld.isRetro())) {
+		if(!this.mc.gameSettings.biomeWater.value || (this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
 			return 0xFFFFFFFF;
 		}
 		return super.getFallbackColor(meta, tintIndex);
 	}
 	
 	@Override
-	public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex) {
-		if(!mc.gameSettings.biomeWater.value || world.isRetro()) {
+	public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
+		if(!this.mc.gameSettings.biomeWater.value || source.isRetro()) {
 			return 0xFFFFFFFF;
 		}
-		return super.getWorldColor(world, x, y, z, tintIndex);
+		return super.getWorldColor(source, tilePos, tintIndex);
 	}
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWireRedstone.java
index 9eea2d4f5..c019718b9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWireRedstone.java
@@ -2,21 +2,20 @@ package net.minecraft.client.render.block.color;
 
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockColorWireRedstone
-    extends BlockColor
-{
+    extends BlockColor {
 
     @Override
-    public int getFallbackColor(int meta, int tintIndex)
-    {
+    public int getFallbackColor(int meta, int tintIndex) {
         return Colors.allRedstoneColors[15].getARGB();
     }
 
     @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z, int tintIndex)
-    {
+    public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
         // Colored by renderer
-    	return Colors.allRedstoneColors[15].getARGB();
+        return Colors.allRedstoneColors[15].getARGB();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 7b141fe5f..b9043ea79 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.DisplayPos;
@@ -21,10 +22,10 @@ public abstract class BlockModel<T extends BlockLogic>
     public BlockModel(final Block<T> block){
         this.block = block;
     }
-    public abstract boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z);
-    public abstract boolean renderOverbright(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z);
-    public abstract boolean renderNoCulling(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z);
-    public abstract boolean renderWithOverrideTexture(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z, IconCoordinate textureIndex);
+    public abstract boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
+    public abstract boolean renderOverbright(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
+    public abstract boolean renderNoCulling(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos);
+    public abstract boolean renderWithOverrideTexture(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, IconCoordinate textureIndex);
     public abstract void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate);
 
     public abstract boolean shouldItemRender3d();
@@ -36,7 +37,7 @@ public abstract class BlockModel<T extends BlockLogic>
 
     public abstract @Nullable IconCoordinate getParticleTexture(@NotNull Side side, int meta);
     public abstract @Nullable IconCoordinate getOverlayTexture(int meta);
-    public abstract int particleColorIndex(@NotNull WorldSource worldSource, int x, int y, int z, @NotNull Side side, int meta);
+    public abstract int particleColorIndex(@NotNull WorldSource worldSource, @NotNull TilePosc tilePos, @NotNull Side side, int meta);
 
     public boolean hasOverbright(){
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
index 01e2d00c4..4d773ef7f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicActivator;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRotatable<T> {
@@ -20,7 +21,7 @@ public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRot
 
     public BlockModelActivator(Block<T> block) {
         super(block);
-        overbrightTextures
+        this.overbrightTextures
             .set("minecraft:block/activator/bottom_active_overlay", Side.BOTTOM)
             .set("minecraft:block/activator/top_active_overlay", Side.TOP)
             .set("minecraft:block/activator/front_active_overlay", Side.SOUTH)
@@ -33,18 +34,16 @@ public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRot
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         if ((data & BlockLogicActivator.MASK_POWERED) != 0) {
-            return poweredTextures[getRotatedSide(side, data).getId()];
+            return this.poweredTextures[getRotatedSide(side, data).getId()];
         } else {
             return super.getBlockTextureFromSideAndMetadata(side, data);
         }
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(@NotNull Side side, int data) {
         boolean isPowered = (data & BlockLogicActivator.MASK_POWERED) != 0;
         if (!isPowered) return null;
         return super.getBlockOverbrightTextureFromSideAndMeta(side, data);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
index a55617fa6..4ae60d49b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
@@ -7,9 +7,10 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBdc;
 
 public class BlockModelAlgae<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelAlgae(Block<T> block) {
@@ -17,40 +18,38 @@ public class BlockModelAlgae<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
         float brightness = 1.0f;
-        if(!LightmapHelper.isLightmapEnabled()) {
-        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
-        }else {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
+        if (!LightmapHelper.isLightmapEnabled()) {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
+        } else {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
         }
 
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(worldSource, x, y, z, 0);
-        float red = (float)(color >> 16 & 0xff) / 255F;
-        float green = (float)(color >> 8 & 0xff) / 255F;
-        float blue = (float)(color & 0xff) / 255F;
+        int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
+        float red = (float) (color >> 16 & 0xff) / 255F;
+        float green = (float) (color >> 8 & 0xff) / 255F;
+        float blue = (float) (color & 0xff) / 255F;
 
         tessellator.setColorOpaque_F(red * brightness, green * brightness, blue * brightness);
-        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.TOP, worldSource.getBlockMetadata(x, y, z));
-        renderBlocks.renderTopFace(tessellator, bounds, x, y - 0.1125, z, tex);
-        renderBlocks.renderBottomFace(tessellator, bounds, x, y + 0.0125, z, tex);
+        IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.TOP, worldSource.getBlockData(tilePos));
+        renderBlocks.renderTopFace(tessellator, bounds, tilePos.x(), tilePos.y() - 0.1125, tilePos.z(), tex);
+        renderBlocks.renderBottomFace(tessellator, bounds, tilePos.x(), tilePos.y() + 0.0125, tilePos.z(), tex);
 
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
     }
+
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
-    {
-        if(side == Side.TOP)
-        {
+    public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
+        if (side == Side.TOP) {
             return true;
-        } else
-        {
-            return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
         }
+        return super.shouldSideBeRendered(source, bounds, tilePos, side);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
index a4fb3b83f..2efffecb6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
@@ -10,6 +10,7 @@ import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -19,11 +20,10 @@ public class BlockModelAxisAligned<T extends BlockLogic> extends BlockModelStand
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int meta = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int meta = worldSource.getBlockData(tilePos);
         Axis axis = BlockLogicAxisAligned.metaToAxis(meta);
-        switch(axis)
-        {
+        switch (axis) {
             case Y:
                 renderBlocks.uvRotateEast = 0;
                 renderBlocks.uvRotateWest = 0;
@@ -43,22 +43,21 @@ public class BlockModelAxisAligned<T extends BlockLogic> extends BlockModelStand
                 renderBlocks.uvRotateBottom = 1;
                 break;
         }
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsFromState(worldSource, tilePos), tilePos);
         renderBlocks.resetRenderBlocks();
 
         return true;
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         Side rotated = getRotatedSide(side, data);
         if (rotated == Side.NONE) return TextureRegistry.getTexture("minecraft:block/grass_top");
         return super.getBlockTextureFromSideAndMetadata(rotated, data);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
+    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(@NotNull Side side, int data) {
         Side rotated = getRotatedSide(side, data);
         if (rotated == Side.NONE) return null;
         return super.getBlockOverbrightTextureFromSideAndMeta(rotated, data);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
index d80fe57bf..fabeaf9fa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
@@ -6,57 +6,56 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicBasket;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
 
 public class BlockModelBasket<T extends BlockLogicBasket> extends BlockModelStandard<T> {
     protected IconCoordinate fillTexture = TextureRegistry.getTexture("minecraft:block/basket/fill");
+
     public BlockModelBasket(Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        AABB bounds = block.getBounds();
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        AABBd bounds = new AABBd(this.block.getBounds());
         // Render basket
         final float onePix = 1.0f / 16;
         final float basketHeight = onePix * 16;
 
         // Basket walls
-        bounds.set(0, 0, 0, 1, onePix, 1);
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // Bottom
+        bounds.setMin(0, 0, 0).setMax(1, onePix, 1);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos); // Bottom
 
         renderBlocks.setRenderSide(Side.EAST, false);
         renderBlocks.setRenderSide(Side.WEST, false);
         renderBlocks.setRenderSide(Side.BOTTOM, false);
-        bounds.set(0, 0, 0, 1, basketHeight, onePix);
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // North
-        bounds.set(0, 0, 1 - onePix, 1, basketHeight, 1); // south
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // South
+        bounds.setMin(0, 0, 0).setMax(1, basketHeight, onePix);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos); // North
+        bounds.setMin(0, 0, 1 - onePix).setMax(1, basketHeight, 1); // south
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos); // South
         renderBlocks.renderBitMask = 0;
 
         renderBlocks.setRenderSide(Side.NORTH, false);
         renderBlocks.setRenderSide(Side.SOUTH, false);
         renderBlocks.setRenderSide(Side.BOTTOM, false);
-        bounds.set(0, 0, 0, onePix, basketHeight, 1);
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // West
-        bounds.set(1 - onePix, 0, 0, 1, basketHeight, 1);
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z); // East
-        bounds.set(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
+        bounds.setMin(0, 0, 0).setMax(onePix, basketHeight, 1);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos); // West
+        bounds.setMin(1 - onePix, 0, 0).setMax(1, basketHeight, 1);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos); // East
+        bounds.setMin(0.0f, 0.0f, 0.0f).setMax(1.0f, 1.0f, 1.0f);
         renderBlocks.renderBitMask = 0;
 
-        final int height = block.getLogic().getFillLevel(worldSource, x, y, z);
+        final int height = this.block.getLogic().getFillLevel(worldSource, tilePos);
         // Interior
-        if (height > 0)
-        {
-            renderBlocks.renderTopFace(tessellator, bounds, x, (y - 1) + onePix + onePix * height, z, fillTexture);
+        if (height > 0) {
+            renderBlocks.renderTopFace(tessellator, bounds, tilePos.x(), (tilePos.y() - 1) + onePix + onePix * height, tilePos.z(), this.fillTexture);
         }
-
-        bounds.set(0, 0, 0, 1, basketHeight, 1);
-
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
index 1287366f8..a3d4b4b01 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
@@ -7,10 +7,12 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 
 public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate underTexture = TextureRegistry.getTexture("minecraft:block/bed/bottom");
@@ -18,101 +20,94 @@ public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
 
     public BlockModelBed(Block<T> block) {
         super(block);
-        bedTextures[0] = TextureRegistry.getTexture("minecraft:block/bed/foot_front");
-        bedTextures[1] = TextureRegistry.getTexture("minecraft:block/bed/foot_side");
-        bedTextures[2] = TextureRegistry.getTexture("minecraft:block/bed/foot_top");
-        bedTextures[3] = TextureRegistry.getTexture("minecraft:block/bed/head_front");
-        bedTextures[4] = TextureRegistry.getTexture("minecraft:block/bed/head_side");
-        bedTextures[5] = TextureRegistry.getTexture("minecraft:block/bed/head_top");
+        this.bedTextures[0] = TextureRegistry.getTexture("minecraft:block/bed/foot_front");
+        this.bedTextures[1] = TextureRegistry.getTexture("minecraft:block/bed/foot_side");
+        this.bedTextures[2] = TextureRegistry.getTexture("minecraft:block/bed/foot_top");
+        this.bedTextures[3] = TextureRegistry.getTexture("minecraft:block/bed/head_front");
+        this.bedTextures[4] = TextureRegistry.getTexture("minecraft:block/bed/head_side");
+        this.bedTextures[5] = TextureRegistry.getTexture("minecraft:block/bed/head_top");
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        AABBd bounds = new AABBd(this.block.getBoundsFromState(worldSource, tilePos));
         renderBlocks.enableAO = true;
-        renderBlocks.cache.setupCache(block, worldSource, x, y, z);
+        renderBlocks.cache.setupCache(this.block, worldSource, tilePos);
 
-        final int meta = worldSource.getBlockMetadata(x, y, z);
+        final int meta = worldSource.getBlockData(tilePos);
         final int direction = BlockLogicBed.getDirection(meta);
         final boolean isFootOfBed = BlockLogicBed.isBlockFootOfBed(meta);
 
         final double minY = bounds.minY;
         bounds.minY += 0.1875D;
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1f, 1f, 1f, Side.BOTTOM, meta);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1f, 1f, 1f, Side.BOTTOM, meta);
         bounds.minY = minY;
 
-        if(direction == 0)
-        {
+        if (direction == 0) {
             renderBlocks.uvRotateTop = 1;
-        } else
-        if(direction == 2)
-        {
+        } else if (direction == 2) {
             renderBlocks.uvRotateTop = 2;
-        } else
-        if(direction == 1)
-        {
+        } else if (direction == 1) {
             renderBlocks.uvRotateTop = 3;
         }
-        renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.TOP, meta);
+        renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.TOP, meta);
 
         renderBlocks.uvRotateTop = 0;
         final int f17 = isFootOfBed ? BlockLogicBed.headOfBedMap[BlockLogicBed.footToHeadMap[direction]] : BlockLogicBed.headOfBedMap[direction];
 
-        if(f17 != 2 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, x, y, z - 1, Side.NORTH)))
-        {
+        if (f17 != 2 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, tilePos.north(queryPos), Side.NORTH))) {
             renderBlocks.flipTexture = direction == 3;
-            renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.NORTH, meta);
+            renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.NORTH, meta);
         }
 
-        if(f17 != 3 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, x, y, z + 1, Side.SOUTH)))
-        {
+        if (f17 != 3 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, tilePos.south(queryPos), Side.SOUTH))) {
             renderBlocks.flipTexture = direction == 1;
-            renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.SOUTH, meta);
+            renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.SOUTH, meta);
         }
 
-        if(f17 != 4 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, x - 1, y, z, Side.WEST)))
-        {
+        if (f17 != 4 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, tilePos.west(queryPos), Side.WEST))) {
             renderBlocks.flipTexture = direction == 2;
-            renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.WEST, meta);
+            renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.WEST, meta);
         }
 
-        if(f17 != 5 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, x + 1, y, z, Side.EAST)))
-        {
+        if (f17 != 5 && (renderBlocks.renderAllFaces || shouldSideBeRendered(worldSource, bounds, tilePos.east(queryPos), Side.EAST))) {
             renderBlocks.flipTexture = direction == 0;
-            renderBlocks.renderSide(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1, Side.EAST, meta);
+            renderBlocks.renderSide(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1, Side.EAST, meta);
         }
         renderBlocks.resetRenderBlocks();
         return true;
     }
+
     @Override
-    public boolean shouldItemRender3d(){
+    public boolean shouldItemRender3d() {
         return false;
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
-        if(side == Side.BOTTOM) {
-            return underTexture;
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        if (side == Side.BOTTOM) {
+            return this.underTexture;
         }
         int k = BlockLogicBed.getDirection(data);
         int l = BlockLogicBed.bedDirection[k][side.getId()];
-        if(BlockLogicBed.isBlockFootOfBed(data)) {
-            if(l == 2) {
-                return bedTextures[3];
+        if (BlockLogicBed.isBlockFootOfBed(data)) {
+            if (l == 2) {
+                return this.bedTextures[3];
             }
-            if(l == 5 || l == 4) {
-                return bedTextures[4];
+            if (l == 5 || l == 4) {
+                return this.bedTextures[4];
             } else {
-                return bedTextures[5];
+                return this.bedTextures[5];
             }
         }
-        if(l == 3) {
-            return bedTextures[0];
+        if (l == 3) {
+            return this.bedTextures[0];
         }
-        if(l == 5 || l == 4) {
-            return bedTextures[1];
+        if (l == 5 || l == 4) {
+            return this.bedTextures[1];
         } else {
-            return bedTextures[2];
+            return this.bedTextures[2];
         }
     }
 }
